#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com"  

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  DeepPink
#property indicator_color3  DarkSlateGray
#property indicator_color4  DarkSlateGray
#property indicator_color5  DarkSlateGray
#property indicator_width1  2
#property indicator_style2  STYLE_DASH
#property indicator_style3  STYLE_DASHDOTDOT
#property indicator_style4  STYLE_DASHDOTDOT
#property indicator_style5  STYLE_DASHDOTDOT

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern double VelWprPeriod        = 25;
extern double SignalPeriod        = 5;
extern int    SignalMode          = MODE_EMA;
extern int    VelWprPrice         = 0;
extern int    MinMaxPeriod        = 25;
extern double levelOb             = 7;
extern double levelOs             = -7;  
extern bool   Interpolate         = true;

extern bool   alertsOn            = false;
extern bool   alertsOnSlope       = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;

extern bool   arrowsVisible       = true;
extern string arrowsIdentifier    = "velwprArrows1";
extern double arrowsDisplacement  = 1.0;
extern color  arrowsUpColor       = LimeGreen;
extern color  arrowsDnColor       = DeepPink;
extern bool   arrowsOnSlope       = true;
extern bool   arrowsOnSignalCross = false;

//
//
//
//
//

double VelWpr[];
double VelWprma[];
double levelUp[];
double levelMi[];
double levelDn[];
double slope[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,VelWpr);
   SetIndexBuffer(1,VelWprma);
   SetIndexBuffer(2,levelUp);
   SetIndexBuffer(3,levelMi);
   SetIndexBuffer(4,levelDn);
   SetIndexBuffer(5,slope); 
   SetIndexBuffer(6,trend); 
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"   Vel %r ("+DoubleToStr(VelWprPeriod,2)+","+DoubleToStr(SignalPeriod,2)+")");   
return(0);
}

//
//
//
//
//
              
int deinit()
{

   if (!calculateValue && arrowsVisible) deleteArrows();  
    
return(0);
}
  
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
        limit = MathMin(Bars-counted_bars,Bars-1);
        if (returnBars)  { VelWpr[0] = limit+1; return(0); }   
           
   //
   //
   //
   //
   //
           
   if (calculateValue || timeFrame == Period())
   {
      
       for (i=limit; i>=0; i--)
       {
          double pr = getPrice(VelWprPrice,i);
          double hi = High[iHighest(NULL,0,MODE_HIGH,VelWprPeriod,i)];
          double lo =  Low[ iLowest(NULL,0,MODE_LOW, VelWprPeriod,i)];         
          if (hi!=lo)
               VelWpr[i] = iVelocity(50+(-100)*(hi-pr) /(hi-lo),VelWprPeriod,i);
          else VelWpr[i] = iVelocity(0                         ,VelWprPeriod,i);  
        }
               
               //
               //
               //
               //
               //
               
               for(i=limit; i>=0; i--)
               {
                  VelWprma[i]  = iMAOnArray(VelWpr,0,SignalPeriod,0,SignalMode,i); 
                  double Min   = VelWpr[ArrayMinimum(VelWpr,MinMaxPeriod,i)];
                  double Max   = VelWpr[ArrayMaximum(VelWpr,MinMaxPeriod,i)];
                  double range = Max-Min;
                  levelMi[i] = Min+range/2; 
                  levelUp[i] = levelMi[i]+levelOb;
                  levelDn[i] = levelMi[i]+levelOs;
                  slope[i] = slope[i+1];
                  trend[i] = trend[i+1];
                     if (VelWpr[i] < VelWpr[i+1]) slope[i] = -1;
                     if (VelWpr[i] > VelWpr[i+1]) slope[i] =  1;
                     if (VelWpr[i] < VelWprma[i]) trend[i] = -1;
                     if (VelWpr[i] > VelWprma[i]) trend[i] =  1;
                        manageArrow(i);
      
               } 
   manageAlerts();          
   return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         VelWpr[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VelWprPeriod,SignalPeriod,SignalMode,VelWprPrice,MinMaxPeriod,levelOb,levelOs,0,y);
         VelWprma[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VelWprPeriod,SignalPeriod,SignalMode,VelWprPrice,MinMaxPeriod,levelOb,levelOs,1,y);
         levelUp[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VelWprPeriod,SignalPeriod,SignalMode,VelWprPrice,MinMaxPeriod,levelOb,levelOs,2,y);
         levelMi[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VelWprPeriod,SignalPeriod,SignalMode,VelWprPrice,MinMaxPeriod,levelOb,levelOs,3,y);
         levelDn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VelWprPeriod,SignalPeriod,SignalMode,VelWprPrice,MinMaxPeriod,levelOb,levelOs,4,y);
         slope[i] = slope[i+1];
         trend[i] = trend[i+1];

            if (VelWpr[i] < VelWpr[i+1]) slope[i] = -1;
            if (VelWpr[i] > VelWpr[i+1]) slope[i] =  1;
            if (VelWpr[i] < VelWprma[i]) trend[i] = -1;
            if (VelWpr[i] > VelWprma[i]) trend[i] =  1;
              manageArrow(i);
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               VelWpr[i+k]   = VelWpr[i]   + (VelWpr[i+n]   - VelWpr[i])   * k/n;
               VelWprma[i+k] = VelWprma[i] + (VelWprma[i+n] - VelWprma[i]) * k/n;
               levelUp[i+k]  = levelUp[i]  + (levelUp[i+n]  - levelUp[i])  * k/n;
               levelMi[i+k]  = levelMi[i]  + (levelMi[i+n]  - levelMi[i])  * k/n;
               levelDn[i+k]  = levelDn[i]  + (levelDn[i+n]  - levelDn[i])  * k/n;
                 
            }                  
     } 
     manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}
        
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double prices[];
double iVelocity(double price, double length, int i)
{
   if (ArraySize(prices)!=Bars) ArrayResize(prices,Bars); i=Bars-i-1;
   
      prices[i] = price;
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;

      for(int k=0; k<length; k++)
      {
         double weight = length-k;
            suma  += prices[i-k] * weight;
            sumb  += prices[i-k] * weight * weight;
            sumwa += weight;
            sumwb += weight*weight;
      }
   return(sumb/sumwb-suma/sumwa);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," VelWpr sloping up");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," VelWpr sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar," VelWpr crossed signal line up");
            if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar," VelWpr crossed signal line down");
         }            
    }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," VelWpr "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1)  drawArrow(i,arrowsUpColor,200,false);
         if (slope[i] ==-1)  drawArrow(i,arrowsDnColor,201,true);
      }
      if (arrowsOnSignalCross && trend[i]!= trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
      
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
      string name = arrowsIdentifier+":"+Time[i];
      double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


